package me.flashyreese.mods.sodiumextra.mixin.fog;

import com.mojang.blaze3d.systems.RenderSystem;
import me.flashyreese.mods.sodiumextra.client.SodiumExtraClientMod;
import net.minecraft.class_1294;
import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1959;
import net.minecraft.class_3532;
import net.minecraft.class_4184;
import net.minecraft.class_5636;
import net.minecraft.class_6854;
import net.minecraft.class_6880;
import net.minecraft.class_746;
import net.minecraft.class_758;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(class_758.class)
public class MixinBackgroundRenderer {

    //Todo: Re write this implementation
    @Inject(method = "applyFog", at = @At(value = "HEAD"), cancellable = true)
    private static void applyFog(class_4184 camera, class_758.class_4596 fogType, float viewDistance, boolean thickFog, CallbackInfo info) {
        if (SodiumExtraClientMod.options().renderSettings.fogDistance != 0) {
            vanillaApplyFog(camera, fogType, viewDistance, thickFog);
            info.cancel();
        }
    }

    // Vanilla copy
    private static void vanillaApplyFog(class_4184 camera, class_758.class_4596 fogType, float viewDistance, boolean thickFog) {
        float g;
        float f;
        class_5636 cameraSubmersionType = camera.method_19334();
        class_1297 entity = camera.method_19331();
        class_6854 fogShape = class_6854.field_36350;
        if (cameraSubmersionType == class_5636.field_27885) {
            if (entity.method_7325()) {
                f = -8.0f;
                g = viewDistance * 0.5f;
            } else if (entity instanceof class_1309 && ((class_1309)entity).method_6059(class_1294.field_5918)) {
                f = 0.0f;
                g = 3.0f;
            } else {
                f = 0.25f;
                g = 1.0f;
            }
        } else if (cameraSubmersionType == class_5636.field_27887) {
            if (entity.method_7325()) {
                f = -8.0f;
                g = viewDistance * 0.5f;
            } else {
                f = 0.0f;
                g = 2.0f;
            }
        } else if (entity instanceof class_1309 && ((class_1309)entity).method_6059(class_1294.field_5919)) {
            int i = ((class_1309)entity).method_6112(class_1294.field_5919).method_5584();
            float h = class_3532.method_16439(Math.min(1.0f, (float)i / 20.0f), viewDistance, 5.0f);
            if (fogType == class_758.class_4596.field_20945) {
                f = 0.0f;
                g = h * 0.8f;
            } else {
                f = cameraSubmersionType == class_5636.field_27886 ? -4.0f : h * 0.25f;
                g = h;
            }
        } else if (cameraSubmersionType == class_5636.field_27886) {
            f = -8.0f;
            g = 96.0f;
            if (entity instanceof class_746) {
                class_746 clientPlayerEntity = (class_746)entity;
                g *= Math.max(0.25f, clientPlayerEntity.method_3140());
                class_6880<class_1959> registryEntry = clientPlayerEntity.field_6002.method_23753(clientPlayerEntity.method_24515());
                if (class_1959.method_40136(registryEntry) == class_1959.class_1961.field_9364) {
                    g *= 0.85f;
                }
            }
            if (g > viewDistance) {
                g = viewDistance;
                fogShape = class_6854.field_36351;
            }
        } else if (thickFog) {
            if (SodiumExtraClientMod.options().renderSettings.fogDistance == 33) {
                // Terrible hack to disable the fog, also breaks fog occlusion culling
                // Todo: Per dimension fog toggles and sliders perhaps
                f = Short.MAX_VALUE - 1;
                g = Short.MAX_VALUE;
            } else if (SodiumExtraClientMod.options().renderSettings.fogDistance != 0) {
                f = SodiumExtraClientMod.options().renderSettings.fogDistance * 16;
                g = (SodiumExtraClientMod.options().renderSettings.fogDistance + 1) * 16;
            } else {
                f = viewDistance * 0.05f;
                g = Math.min(viewDistance, 192.0f) * 0.5f;
            }
        } else if (fogType == class_758.class_4596.field_20945) {
            f = 0.0f;
            g = viewDistance;
            fogShape = class_6854.field_36351;
        } else {
            float j = class_3532.method_15363(viewDistance / 10.0f, 4.0f, 64.0f);

            if (SodiumExtraClientMod.options().renderSettings.fogDistance == 33) {
                // Terrible hack to disable the fog, also breaks fog occlusion culling
                // Todo: Per dimension fog toggles and sliders perhaps
                f = Short.MAX_VALUE - 1;
                g = Short.MAX_VALUE;
            } else if (SodiumExtraClientMod.options().renderSettings.fogDistance != 0) {
                f = SodiumExtraClientMod.options().renderSettings.fogDistance * 16;
                g = (SodiumExtraClientMod.options().renderSettings.fogDistance + 1) * 16;
            } else {
                f = viewDistance - j;
                g = viewDistance;
            }
            fogShape = class_6854.field_36351;
        }
        RenderSystem.setShaderFogStart(f);
        RenderSystem.setShaderFogEnd(g);
        RenderSystem.setShaderFogShape(fogShape);
    }
}
